// SetupTokenDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SetupToken.h"
#include "SetupTokenDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupTokenDlg dialog

CSetupTokenDlg::CSetupTokenDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSetupTokenDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetupTokenDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSetupTokenDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupTokenDlg)
	DDX_Control(pDX, IDC_BUTTON_SET, m_btnSet);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSetupTokenDlg, CDialog)
	//{{AFX_MSG_MAP(CSetupTokenDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	ON_BN_CLICKED(IDC_BUTTON_SET, OnButtonSet)
	ON_EN_CHANGE(IDC_EDIT_PID, OnChangeEditPid)
	ON_EN_CHANGE(IDC_EDIT_SOPIN, OnChangeEditSopin)
	ON_EN_CHANGE(IDC_EDIT_SOPIN_RETRY, OnChangeEditSopinRetry)
	ON_EN_CHANGE(IDC_EDIT_USERPIN_RETRY, OnChangeEditUserpinRetry)
	ON_EN_CHANGE(IDC_EDIT_READ_ONLY, OnChangeEditReadOnly)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupTokenDlg message handlers

BOOL CSetupTokenDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSetupTokenDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSetupTokenDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSetupTokenDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSetupTokenDlg::OnExit() 
{
	// TODO: Add your control notification handler code here
	CDialog::OnOK();
}

void CSetupTokenDlg::OnButtonSet() 
{
	// 
	unsigned char longPid[8];
	int tokenCount;
	ET_HANDLE hET99;
	unsigned long ret = ET_SUCCESS;
	BYTE SoPinRetryCount=0;
	BYTE UserPinRetryCount=0;
	BYTE ReadOnlyFlag=0;

	GetDlgItemText(IDC_EDIT_PID,Pid);
	GetDlgItemText(IDC_EDIT_SOPIN,SoPin);
	GetDlgItemText(IDC_EDIT_SOPIN_RETRY,SoPinRetry);
	GetDlgItemText(IDC_EDIT_USERPIN_RETRY,UserPinRetry);
	GetDlgItemText(IDC_EDIT_READ_ONLY,ReadOnly);
	memcpy(longPid,Pid.GetBuffer(0),8);
	//sscanf(Pid.GetBuffer(0),"%lx",&longPid);
	ret = et_FindToken(longPid,&tokenCount);
	if(ET_SUCCESS!=ret)
	{
		MessageBox("ҲָET99!","SetupToken",MB_OK|MB_ICONSTOP);
		return;
	}
	else
	{
		if(1!=tokenCount)
		{
			MessageBox("ҵָET99ֹ1!","SetupToken",MB_OK|MB_ICONSTOP);
			return;
		}
	}
	ret = et_OpenToken(&hET99,longPid,1);
	if(ET_SUCCESS!=ret)
	{
		MessageBox("ET99ʧ!","SetupToken",MB_OK|MB_ICONSTOP);
		return;
	}
	ret = et_Verify(hET99,1,(unsigned char *)SoPin.GetBuffer(0));
	if(ET_SUCCESS!=ret)
	{
		MessageBox("ûPIN!","SetupToken",MB_OK|MB_ICONSTOP);
		et_CloseToken(hET99);
		return;
	}
	sscanf(SoPinRetry.GetBuffer(0),"%ld",&SoPinRetryCount);
	sscanf(UserPinRetry.GetBuffer(0),"%ld",&UserPinRetryCount);
	sscanf(ReadOnly.GetBuffer(0),"%ld",&ReadOnlyFlag);
	if((0>SoPinRetryCount)||(15<SoPinRetryCount)||(0>UserPinRetryCount)||(15<UserPinRetryCount)||!(ReadOnlyFlag==0||ReadOnlyFlag==1))
	{
		MessageBox("д!","SetupToken",MB_OK|MB_ICONSTOP);
		et_CloseToken(hET99);
		return;
	}
	ret = et_SetupToken(hET99,SoPinRetryCount,UserPinRetryCount,ReadOnlyFlag,0);
	if(ET_SUCCESS!=ret)
	{
		MessageBox("ET99ʧ!","SetupToken",MB_OK|MB_ICONSTOP);
		et_CloseToken(hET99);
		return;
	}
	else
	{
		MessageBox("ET99ɹ! ","SetupToken",MB_OK|MB_ICONINFORMATION);
	}
	et_CloseToken(hET99);
}

void CSetupTokenDlg::OnChangeEditPid() 
{
	GetDlgItemText(IDC_EDIT_PID,Pid);
	GetDlgItemText(IDC_EDIT_SOPIN,SoPin);
	GetDlgItemText(IDC_EDIT_SOPIN_RETRY,SoPinRetry);
	GetDlgItemText(IDC_EDIT_USERPIN_RETRY,UserPinRetry);
	GetDlgItemText(IDC_EDIT_READ_ONLY,ReadOnly);
	if((8!=Pid.GetLength())||(16!=SoPin.GetLength())
		||(0==SoPinRetry.GetLength())||(SoPinRetry.GetLength()>2)
		||(0==UserPinRetry.GetLength())||(UserPinRetry.GetLength()>2)
		||(0==ReadOnly.GetLength())||(ReadOnly.GetLength()>1))
		m_btnSet.EnableWindow(FALSE);
	else
		m_btnSet.EnableWindow(TRUE);
}

void CSetupTokenDlg::OnChangeEditSopin() 
{
	GetDlgItemText(IDC_EDIT_PID,Pid);
	GetDlgItemText(IDC_EDIT_SOPIN,SoPin);
	GetDlgItemText(IDC_EDIT_SOPIN_RETRY,SoPinRetry);
	GetDlgItemText(IDC_EDIT_USERPIN_RETRY,UserPinRetry);
	GetDlgItemText(IDC_EDIT_READ_ONLY,ReadOnly);
	if((8!=Pid.GetLength())||(16!=SoPin.GetLength())
		||(0==SoPinRetry.GetLength())||(SoPinRetry.GetLength()>2)
		||(0==UserPinRetry.GetLength())||(UserPinRetry.GetLength()>2)
		||(0==ReadOnly.GetLength())||(ReadOnly.GetLength()>1))
		m_btnSet.EnableWindow(FALSE);
	else
		m_btnSet.EnableWindow(TRUE);
}

void CSetupTokenDlg::OnChangeEditSopinRetry() 
{
	GetDlgItemText(IDC_EDIT_PID,Pid);
	GetDlgItemText(IDC_EDIT_SOPIN,SoPin);
	GetDlgItemText(IDC_EDIT_SOPIN_RETRY,SoPinRetry);
	GetDlgItemText(IDC_EDIT_USERPIN_RETRY,UserPinRetry);
	GetDlgItemText(IDC_EDIT_READ_ONLY,ReadOnly);
	if((8!=Pid.GetLength())||(16!=SoPin.GetLength())
		||(0==SoPinRetry.GetLength())||(SoPinRetry.GetLength()>2)
		||(0==UserPinRetry.GetLength())||(UserPinRetry.GetLength()>2)
		||(0==ReadOnly.GetLength())||(ReadOnly.GetLength()>1))
		m_btnSet.EnableWindow(FALSE);
	else
		m_btnSet.EnableWindow(TRUE);
}

void CSetupTokenDlg::OnChangeEditUserpinRetry() 
{
	GetDlgItemText(IDC_EDIT_PID,Pid);
	GetDlgItemText(IDC_EDIT_SOPIN,SoPin);
	GetDlgItemText(IDC_EDIT_SOPIN_RETRY,SoPinRetry);
	GetDlgItemText(IDC_EDIT_USERPIN_RETRY,UserPinRetry);
	GetDlgItemText(IDC_EDIT_READ_ONLY,ReadOnly);
	if((8!=Pid.GetLength())||(16!=SoPin.GetLength())
		||(0==SoPinRetry.GetLength())||(SoPinRetry.GetLength()>2)
		||(0==UserPinRetry.GetLength())||(UserPinRetry.GetLength()>2)
		||(0==ReadOnly.GetLength())||(ReadOnly.GetLength()>1))
		m_btnSet.EnableWindow(FALSE);
	else
		m_btnSet.EnableWindow(TRUE);
}

void CSetupTokenDlg::OnChangeEditReadOnly() 
{
	GetDlgItemText(IDC_EDIT_PID,Pid);
	GetDlgItemText(IDC_EDIT_SOPIN,SoPin);
	GetDlgItemText(IDC_EDIT_SOPIN_RETRY,SoPinRetry);
	GetDlgItemText(IDC_EDIT_USERPIN_RETRY,UserPinRetry);
	GetDlgItemText(IDC_EDIT_READ_ONLY,ReadOnly);
	if((8!=Pid.GetLength())||(16!=SoPin.GetLength())
		||(0==SoPinRetry.GetLength())||(SoPinRetry.GetLength()>2)
		||(0==UserPinRetry.GetLength())||(UserPinRetry.GetLength()>2)
		||(0==ReadOnly.GetLength())||(ReadOnly.GetLength()>1))
		m_btnSet.EnableWindow(FALSE);
	else
		m_btnSet.EnableWindow(TRUE);
}

void CSetupTokenDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	//CDialog::OnOK();
}
